'Zhler 10.000-manuell mit Offset.bas : Frequenzzhler mit Offset und Lcd -Anzeige

'Entwickler:                            Wolfgang March (auf Basis "FQ2.bas" von Roland Walter)



'***********************************************************************************************************************



'Hardware: LCD-Anzeige mit HD4478-kompatibler Schnittstelle

'          LCD-Verbindungen:

'          LCD01 an Masse (VSS)

'          LCD02 an +5V   (VDD)

'          LCD03 an Poti  (V0)

'          LCD04 an PC5   (RS)

'          LCD05 an Masse

'          LCD06 an PC4   (E)

'          LCD11 an PC3

'          LCD12 an PC2

'          LCD13 an PC1

'          LCD14 an PC0



'***************************************************************************************************************************************



$regfile = "m8def.dat"

$crystal = 10000000                                         'Quarz: 10,000MHz



'***************************************************************************************************************************************



Dim Lcount As Long At &H60                                  'Zhler-Variable

Dim Wcountlo As Word At &H60 Overlay                        'LoWord der Zhlervariablen

Dim Wcounthi As Word At &H62 Overlay                        'HiWord der Zhlervariablen

Dim Sresult As String * 16 At &H64                          'Ausgabestring

Dim Result(16) As Byte At &H64 Overlay                      'Ausgabestring als Byte-Array

Dim I As Byte                                               'Stringvariable (Lnge)

Dim Torfaktor As Byte At &H104                              'Faktor fr Tor

Dim Text As String * 16                                     'Text fr Ausgabe oberer LCD-Zeile

Dim Offset As Long At &H100                                 'Offset-Variable

Dim Tahilf As Bit                                           'Merkerbit fr Tasterbettigung

Dim Vor As Byte                                             'Byte fr Voreinstellung

Dim Faktor As Byte At &H105                                 'Merker fr Counter 1-berlufe

'***************************************************************************************************************************************



On Timer1 Oncounteroverflow                                 'Interrupt-Routine frs HiWord des Zhlerstands

Cursor Off                                                  'Cursor aus

Enable Interrupts                                           'Interrupts global einschalten

Enable Counter1                                             'Counter1 Interruptfreigabe



'***************************************************************************************************************************************

'Ein- und Ausgnge konfigurieren



Ddrd = &B11000000                                           'PD0 bis PD5 als Eingnge, PD6 und 7 als Ausgnge

Ddrb = &B00000001                                           'PB0 als Ausgang, PB1 bis PB7 als Eingnge

Portd = &B00111111                                          'Pull Up fr benutzte Eingnge Port D

Portb = &B00000010                                          'Pull Up fr benutzte Eingnge Port B



'***************************************************************************************************************************************

'LCD-Anzeige konfigurieren:



Config Lcd = 16 * 2                                         'LCD-Display mit 16 Zeichen in 2 Zeilen

Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5

Cls

'***************************************************************************************************************************************

'Voreinstellen



Vor = Pind                                                  'Portd in Vor bernehmen

Vor = Not Vor                                               'Zustnde negieren (wegen Pull-UP)

Reset Vor.5                                                 'Bit 5 ausmaskieren

Reset Vor.6                                                 'Bit 6 ausmaskieren

Reset Vor.7                                                 'Bit 7 ausmaskieren



If Vor = 0 And Pinb.1 = 0 Then                              'kein Jumper gesteckt und PortB.1 bettigt (auf Masse)

   Tahilf = 1                                               ' merken, dass bettigt

   Goto Set                                                 'Sprung zu "Setzen"

End If



Goto Main                                                   'Sprung zum Hauptprogramm



Set:                                                        'Setzen



Text = "Offset Eingeben "                                   'Text fr obere Zeile



Goto Anzeige                                                'Sprung zu "Anzeige"



Weiter:                                                     'weiter nach dem Anzeigen



Vor = Pind                                                  'Portd in Vor bernehmen

Vor = Not Vor                                               'Zustnde negieren (wegen Pull-UP)

Reset Vor.5                                                 'Bit 5 ausmaskieren

Reset Vor.6                                                 'Bit 6 ausmaskieren

Reset Vor.7                                                 'Bit 7 ausmaskieren



If Pinb.1 = 1 Then                                          'PortB.1 nicht "mehr" bettigt

   Waitms 100                                               '100 ms warten zur Tastenentprellung

If Pinb.1 = 1 Then                                          'PortB.1 nicht "mehr" bettigt

   Tahilf = 0                                               'merken, dass nicht bettigt

End If

End If



If Tahilf = 0 And Pinb.1 = 0 Then                           'PortB.1 wird bettigt (Wechsel)

   Select Case Vor                                          'Abfrage, welcher Jumper gesteckt

   Case 16 : Lcount = Lcount + 10                           'Lcount als Offsetvariable(lcunt in Anzeige verwendet)

   Case 8 : Lcount = Lcount + 100                           'Erhhung, je nachdem, welcher Jumper gesteckt

   Case 4 : Lcount = Lcount + 1000

   Case 2 : Lcount = Lcount + 10000

   Case 1 : Lcount = Lcount + 100000

   Case 0 : Writeeeprom Lcount , 0                          'kein Jumper "mehr" gesteckt, bernahme des Wertes in EEPROM

             Goto Main                                      'Sprung zum Hauptprogramm

   End Select                                               'Ende der "Jumperabfrage"

   Tahilf = 1                                               'merken, dass bettigt                                               '

   Goto Anzeige                                             'Sprung zu "Anzeige"

End If



Goto Weiter                                                 'in Abfrageschleife bleiben

'***************************************************************************************************************************************

'Beginn Hauptprogramm



Main:



If Pind.0 = 1 Then                                          'Portd.0 = 1 (nicht bettigt)

   Portd.7 = 1                                              'Eingangskanal A aktiviert

   Portd.6 = 0                                              'Eingangskanal B deaktiviert

   Torfaktor = 8                                            'Torzhler 8 mal durchlaufen

   Faktor = 10                                              'Korrekturfaktor fr Interrupts

Else                                                        'Portd.0 = 0 (bettigt)

   Portd.6 = 1                                              'Eingangskanal B aktiviert

   Portd.7 = 0                                              'Eingangskanal A deaktiviert

   Torfaktor = 32                                           'Torzhler 32 mal durchlaufen

   Faktor = 40                                              'Korrekturfaktor fr Interrupts

End If



   Lcount = 0                                               'Zhlervariable lschen

   Readeeprom Offset , 0                                    'Offset in Offset-Variable (Lcount jetzt Zhler-Variable)



$asm                                                        'Assembler starten



   LDI r25,&B00000111                                       'Counter1 (Zhler, fallende Flanke)

   Out Tccr1b , R25                                         'in TCCR1B schreiben und damit Starten

   Lds r19,&H104                                            'Torfaktor in R19 laden(8 bzw. 32 Durchlufe)

Label3:                                                     'Schleife fr Torfaktor

   Ldi r21,199                                              '199 Durchlufe fr uere Schleife

Label2:                                                     'uere Schleife

   ldi r20,250                                              '250 Durchlufe fr innere Schleife

Label1:                                                     'innere Schleife

   dec r20                                                  'R20 um 1 herunterzhlen

   nop                                                      'Flltakt

   brne Label1                                              'Rcksprung, bis Register = 0

   dec r21                                                  'R21 um 1 herunterzhlen

   brne  Label2                                             'Rcksprung, bis Register =0

'kleine Fllschleife als Zusatzzeit

   ldi r18,77                                               '77 Durchlufe fr "Fllschleife"

Label6:                                                     '"Fllschleife"

   dec r18                                                  'R18 um 1 herunterzhlen

   brne  Label6                                             'Rcksprung, bis Register 0

'jetzt wird der Torfaktor bercksichtigt

   dec r19                                                  'R19 um 1 herunterzhlen

   brne Label3                                              'Rcksprung, bis Register = 0

'Korrekturzeit Fr Auswirkung der Interrupts

   Lds r23, &H105                                           'R23 mit Startwert fr Durchlufe laden

Label5:                                                     'Bercksichtigung der Interrupts

   ldi r22,47                                               '47 Durchlufe fr Zeitschleife

Label4:                                                     'Zeitschleife fr Interruptzeit

   dec r22                                                  'R22 um 1 herunterzhlen

   brne label4                                              'Rcksprung, bis Register =0

   dec r23                                                  'R23 um 1 herunterzhlen

   brne label5                                              'Rcksprung, bis Register =0



   LDI r25,&B00000000                                       'alle Bits auf 0 fr TCCR1B

   Out Tccr1b , R25                                         'in TCCR1B schreiben und damit Counter anhalten

$end Asm                                                    'Assambler beenden



Wcountlo = Counter1                                         'Zhlerwert Bit 0 bis 15 bernehmen

Counter1 = 0                                                'Zhler lschen

Text = " Anzeige in kHz "                                   'Text fr obere Zeile (wird evtl. berschrieben durch Folgetexte)



If Pind.3 = 0 Then                                          'Abfrage PortD.3

   Lcount = Lcount + Offset                                 ' Offsetvariable zur Zhlervariable addieren

   Text = " kHz (+ Offset) "                                'Textanzeige dafr

End If



If Pind.4 = 0 Then                                          'Abfrage PortD.3

   Lcount = Lcount - Offset                                 'Offsetvariable von Zhlervariablen subtrahieren

   Text = " kHz (- Offset) "                                'Textanzeige dafr

End If



Goto Anzeige                                                'Sprung zum Anzeigeprogramm



'***************************************************************************************************************************************



Anzeige:                                                    'Anzeigeprogramm



Sresult = "    " + Str(lcount)                              'Wert in String umwandeln und Anzeige 4 Stellen n.Rechts

I = Len(sresult)                                            'Stellenzahl String

Result(i + 1) = Result(i)                                   'Letzte Stelle um ein Zeichen nach Rechts rcken

Result(i) = &H2C                                            'Komma

Result(i + 2) = &H20                                        'Leerzeichen

Result(i + 3) = &H20                                        'Leerzeichen

Result(i + 4) = &H20                                        'Leerzeichen



Home Lower                                                  'Untere Zeile

Lcd Sresult                                                 'Anzeige Sresult (bearbeiteter Zhlerwert)



Home Upper                                                  'Obere Zeile

Lcd Text                                                    'ausgewhlter text anzeigen



If Tahilf = 1 Then                                          'wenn Taster noch bettigt zu "Weiter" zurckspringen

   Goto Weiter

Else

   Goto Main                                                'ansonsten zum Hauptprogrammstart

End If



'***************************************************************************************************************************************



Oncounteroverflow:                                          'Interruptroutine fr Counter1-berlauf

   Decr Faktor                                              'Faktor bei jedem Interrupt um 1 herunterzhlen

   Incr Wcounthi                                            'HiWord der Zhlervariablen erhhen (lCount=lCount+65536)

   Return                                                   'Rcksprung



'***************************************************************************************************************************************
