
'10_000_auto.BAS:      Frequenzzhler mit LCD-Anzeige

'Entwickler:           Wolfgang March (auf Basis "FQ2.bas" von Roland Walter)

'***************************************************************************************************************************************

'Hardware: LCD-Anzeige mit HD4478-kompatibler Schnittstelle

'          LCD-Verbindungen:

'          LCD01 an Masse (VSS)

'          LCD02 an +5V   (VDD)

'          LCD03 an Poti  (V0)

'          LCD04 an PC5   (RS)

'          LCD05 an Masse

'          LCD06 an PC4   (E)

'          LCD11 an PC3

'          LCD12 an PC2

'          LCD13 an PC1

'          LCD14 an PC0

'***************************************************************************************************************************************

$regfile = "m8def.dat"

$crystal = 10000000                                         'Quarz: 10,000MHz

'***************************************************************************************************************************************

Dim Lcount As Long At &H60                                  'Zhler-Variable

Dim Wcountlo As Word At &H60 Overlay                        'LoWord der Zhlervariablen

Dim Wcounthi As Word At &H62 Overlay                        'HiWord der Zhlervariablen

Dim Sresult As String * 16 At &H64                          'Ausgabestring

Dim Result(16) As Byte At &H64 Overlay                      'Ausgabestring als Byte-Array

Dim Stempcount As String * 10 At &H75                       'Mu Len(Str(&HFFFFFFFF)) lang sein

Dim Tempcount(10) As Byte At &H75 Overlay                   'Temp-String als Byte-Array

Dim I As Byte

Dim Gate As Word                                            'Zhler fr Timer 0-Umlufe

Dim Torfaktor As Byte                                       'Faktor fr Torzeitzhlerdurchlauf

Dim Text As String * 16                                     'Text fr obere Zeile

Dim Speicher As Long                                        'Zwischenspeicher

'***************************************************************************************************************************************

'Timer0 (Torzeit) und Timer1 (Zhler) konfigurieren:

On Timer0 Ongatetime                                        'Interrupt-Routine fr die Torzeit

On Timer1 Oncounteroverflow                                 'Interrupt-Routine frs HiWord des Zhlerstands

Config Timer0 = Timer , Prescale = 256                      'Torzeit-Timer mit Takt/256

Config Timer1 = Counter , Edge = Falling                    'Zhler an (steigender)fallender Signalflanke

'***************************************************************************************************************************************

'Ports konfigurieren

Ddrd = &B11000000                                           'PD6 und 7 als Ausgnge, Rest als Eingnge

Portd = &B00011111                                          'Pull Up fr PD0 bis PD4 setzen

Ddrb = &B00000000                                           'PortB alles Eingnge

Portb = &B00000111                                          'Pull Up fr PB0 bis PB2 setzen

'***************************************************************************************************************************************

'LCD-Anzeige konfigurieren:

Config Lcd = 16 * 2                                         'Wir haben ein LCD-Display mit 16 Zeichen in 2 Zeilen

Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0 , E = Portc.4 , Rs = Portc.5

'***************************************************************************************************************************************

Cursor Off                                                  'LCD-Kursor ausschalten

'Begrungstext Auf der Lcd Ausgeben

Home Upper

Sresult = " Frequenzz" + Chr(&He1) + "hler  "

Lcd Sresult

Home Lower

Lcd "  von DM2CWG    "

Waitms 3000

Home Upper

For I = 1 To 1                                              'Ansteigender Balken

   Lcd Chr(255)                                             'Schwarzes Karo

   Waitms 30

Next I

Home Lower

For I = 1 To 16                                             'Ansteigender Balken

   Lcd Chr(255)                                             'Schwarzes Karo

   Waitms 30

Next I

'***************************************************************************************************************************************

Enable Timer0                                               'Timer0-Interrupts ein (Torzeit)

Enable Interrupts                                           'Interrupts global einschalten

'***************************************************************************************************************************************

'Hauptprogramm

Main:

   Portd.7 = 1                                              'Eingangskanal A aktiviert

   Portd.6 = 0                                              'Eingangskanal B deaktiviert

   Torfaktor = 25                                           'Torzhler 25 mal Durchlaufen

   Text = "Kanal A < 45 MHz"                                'Textanzeige fr Kanal A

   Start Timer0                                             'Start Interruptroutine

   Waitms 3000                                              'Warten 3 sec.

Label1:                                                     'Schleife Kanal A

   If Speicher > 100 Then                                   'Abfrage, ob gezhlt wurde

   Goto Label1                                              'wenn "ja" in Schleife Kanal A bleiben

   Stop Timer0                                              'ansonsten stoppen

Else                                                        'oder

   Portd.6 = 1                                              'Eingangskanal B aktiviert

   Portd.7 = 0                                              'Eingangskanal A deaktiviert

   Torfaktor = 100                                          'Torzhler 40 mal durchlaufen

   Text = "Kanal B > 45 MHz"                                'Textanzeige fr Kanal B

   Start Timer0                                             'Start Interruptroutine

   Waitms 3000                                              'Warten 3 sec.

Label2:                                                     'Schleife Kanal B

   If Speicher > 100 Then                                   'Abfrage, ob gezhlt wurde

   Goto Label2                                              'wenn "ja" in Schleife Kanal B bleiben

   End If

   End If

   Stop Timer0                                              'ansonsten stoppen

Goto Main                                                   'Sprung zum Hauptprogrammbeginn

'***************************************************************************************************************************************

Ongatetime:                                                 'Timer 0 Torzeit beendet (1 Durchlauf)

   Timer0 = 6                                               ' Timer 0 auf "6" voreinstellen

   If Gate = 0 Then                                         'Abfrage, ob 1. Umlauf

   Enable Counter1                                          'Zhler-Overflow-Interrupts einschalten

   Start Counter1                                           'Start Counter 1

   Gate = 1                                                 'Startwert fr Umlaufzhler setzen

   Elseif Gate < Torfaktor Then                             '"Torfaktor"-Timer0-Umlufe warten

   Incr Gate                                                'Umlaufzhler um 1 erhhen

Else                                                        'weiter, wenn "Torfaktor"-Umlufe vorbei

$asm                                                        'Beginn Assembler

    clr  r20                                                'Register 20 (R20) lschen

    Loop:                                                   'Beginn Schleife

    inc  r20                                                ' R20 um 1 erhhen

    cpi  r20,20                                             'Prfen, ob 20 mal erhht wurde (20 Schleifendurchlufe)

    brne  LOOP                                              'wenn "nein" Sprung zum Schleifenanfang

    nop                                                     'Flltakt

$end Asm                                                    'Ende Assembler

   Stop Counter1                                            'Tor zumachen, Zhler auslesen

   Disable Counter1                                         'Zhler-Overflow-Interrupts ausschalten

   Wcountlo = Counter1                                      'LoWord in die LONG-Zhlervariable holen

   Speicher = Counter1                                      'damit Zhlwert in Main abgefragt werden kann

   Counter1 = 0                                             'Zhler zurcksetzen (Voreinstellen geht hier auch!)

   Gate = 0                                                 'Umlaufzhler lschen

   Stempcount = Str(lcount)                                 'Wert in String umwandeln

    Sresult = Space(16)

    Result(16) = &H20                                       'Das letzte Zeichen ist immer ein Leerzeichen

    Result(15) = &H20                                       'Das vorletzte Zeichen ist immer ein Leerzeichen

    Result(14) = &H7A

    Result(13) = &H48

    Result(12) = &H4D

    Result(11) = &H20

    I = Len(stempcount)                                     'Aktuelle Position im Quell-String

    Result(10) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(9) = &H2E                                        'ASC(&H2E)="."

    Result(8) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(7) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(6) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(5) = &H2E                                        'ASC(&H2E)="."

    Result(4) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(3) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Result(2) = Tempcount(i) : Decr I

    If I < 1 Then Goto Donestring

    Donestring:

    Lcount = 0                                              'Zhler-Variable zurcksetzen

Home Upper                                                  'In die obere LCD-Zeile gehen

Lcd Text                                                    'Text anzeigen

Home Lower                                                  'In die untere LCD-Zeile gehen

Lcd Sresult

    'Fr die LCD-Anzeige ist inzwischen SEHR viel Zeit vergangen. Inzwischen

    'eingetroffene Timer-Interruptanforderungen sind daher lngst veraltet und

    'wrden uns falsche Zhlerstnde bescheren. Deshalb lschen wir jetzt even-

    'tuell vorhandene Interruptanforderungen:

    Tifr.tov0 = 1                                           'Timer0-Overflow-Flag lschen (nicht = 0!!!)

    Tifr.tov1 = 1                                           'Timer1-Overflow-Flag lschen (nicht = 0!!!)

   End If

Return

'***************************************************************************************************************************************

Oncounteroverflow:                                          'berlaufroutine fr Counter 1

   Incr Wcounthi                                            'HiWord der Zhlervariablen erhhen (lCount=lCount+65536)

Return                                                      'Rcksprung

'***************************************************************************************************************************************
